package net.openseed.osaf.docgen.info;

import java.lang.annotation.Annotation;
import java.lang.reflect.Field;

import javax.persistence.GeneratedValue;

public class PKInfo {

	Field idField;

	String name;
	String type;
	String generationType;
	String generatorName;

	public PKInfo(Field idField) {
		this.idField = idField;

		for (Annotation anno : idField.getAnnotations()) {
			if (anno instanceof GeneratedValue)
				fillGeneratedValueInfo((GeneratedValue) anno);
		}
		fillDefaultValues();
	}

	private void fillDefaultValues() {
		name = idField.getName();
		type = idField.getType().getSimpleName();
	}

	private void fillGeneratedValueInfo(GeneratedValue anno) {
		generationType = anno.strategy().name();
		generatorName = anno.generator();
	}

	public Field getIdField() {
		return idField;
	}

	public String getName() {
		return name;
	}

	public String getType() {
		return type;
	}

	public String getGenerationType() {
		return generationType;
	}

	public String getGeneratorName() {
		return generatorName;
	}

}
